'use strict';

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var msgpack = require('notepack.io');
var Emitter = require('component-emitter');

/**
 * Packet types (see https://github.com/socketio/socket.io-protocol)
 */

var TYPES = {
  CONNECT: 0,
  DISCONNECT: 1,
  EVENT: 2,
  ACK: 3,
  ERROR: 4,
  BINARY_EVENT: 5,
  BINARY_ACK: 6
};

var errorPacket = {
  type: TYPES.ERROR,
  data: 'parser error'
};

var Encoder = function () {
  function Encoder() {
    _classCallCheck(this, Encoder);
  }

  _createClass(Encoder, [{
    key: 'encode',
    value: function encode(packet, callback) {
      switch (packet.type) {
        case TYPES.CONNECT:
        case TYPES.DISCONNECT:
        case TYPES.ERROR:
          return callback([JSON.stringify(packet)]);
        default:
          return callback([msgpack.encode(packet)]);
      }
    }
  }]);

  return Encoder;
}();

var Decoder = function (_Emitter) {
  _inherits(Decoder, _Emitter);

  function Decoder() {
    _classCallCheck(this, Decoder);

    return _possibleConstructorReturn(this, (Decoder.__proto__ || Object.getPrototypeOf(Decoder)).apply(this, arguments));
  }

  _createClass(Decoder, [{
    key: 'add',
    value: function add(obj) {
      if (typeof obj === 'string') {
        this.parseJSON(obj);
      } else {
        this.parseBinary(obj);
      }
    }
  }, {
    key: 'parseJSON',
    value: function parseJSON(obj) {
      try {
        var decoded = JSON.parse(obj);
        this.emit('decoded', decoded);
      } catch (e) {
        this.emit('decoded', errorPacket);
      }
    }
  }, {
    key: 'parseBinary',
    value: function parseBinary(obj) {
      try {
        var decoded = msgpack.decode(obj);
        this.emit('decoded', decoded);
      } catch (e) {
        this.emit('decoded', errorPacket);
      }
    }
  }, {
    key: 'destroy',
    value: function destroy() {}
  }]);

  return Decoder;
}(Emitter);

module.exports = { Encoder: Encoder, Decoder: Decoder };